diff -cr gcc-2.6/cccp.c g:gcc-2.6/cccp.c
*** gcc-2.6/cccp.c	Mon Jul 11 20:07:08 1994
--- g:gcc-2.6/cccp.c	Thu Oct 06 00:21:24 1994
***************
*** 1,3 ****
--- 1,4 ----
+ /* cccp.c -- changed for emx by Eberhard Mattes -- Oct 1994 */
  /* C Compatible Compiler Preprocessor (CCCP)
     Copyright (C) 1986, 87, 89, 92, 93, 1994 Free Software Foundation, Inc.
     Written by Paul Rubin, June 1986
***************
*** 380,385 ****
--- 381,394 ----
  
  static int print_deps_missing_files = 0;
  
+ #ifdef EMX
+ /* Nonzero means use .obj instead of .o for target file when printing
+    dependencies. */
+ 
+ static int omf = 0;
+ 
+ #endif /* EMX */
+ 
  /* Nonzero means print names of header files (-H).  */
  
  static int print_include_names = 0;
***************
*** 1142,1147 ****
--- 1151,1160 ----
    }
  #endif
  
+ #ifdef __EMX__
+   _emxload_env ("GCCLOAD");
+ #endif /* __EMX__ */
+ 
    in_fname = NULL;
    out_fname = NULL;
  
***************
*** 1585,1590 ****
--- 1598,1615 ----
  	inhibit_predefs = 1;
  	break;
  
+ #ifdef EMX
+       case 'Z':
+         if (!strcmp (argv[i], "-Zomf"))
+           omf = 1;
+         else if (!strcmp (argv[i], "-Zc++-comments")
+                  || !strcmp (argv[i], "-ZC++-comments"))
+           cplusplus_comments = 1;
+         else
+           fatal ("Invalid option `%s'", argv[i]);
+         break;
+ #endif /* EMX */
+ 
        case '\0': /* JF handle '-' as file name meaning stdin or stdout */
  	if (in_fname == NULL) {
  	  in_fname = "";
***************
*** 1994,2000 ****
--- 2019,2029 ----
  
        /* Supply our own suffix.  */
  #ifndef VMS
+ #ifndef EMX
        strcpy (q, ".o");
+ #else /* EMX */
+       strcpy (q, omf ? ".obj" : ".o");
+ #endif /* EMX */
  #else
        strcpy (q, ".obj");
  #endif
***************
*** 4172,4178 ****
--- 4201,4211 ----
  
    /* If specified file name is absolute, just open it.  */
  
+ #ifndef __EMX__
    if (*fbeg == '/') {
+ #else /* __EMX__ */
+   if (*fbeg == '/' || *fbeg == '\\' || _fngetdrive (fbeg) != 0) {
+ #endif /* __EMX__ */
      strncpy (fname, fbeg, flen);
      fname[flen] = 0;
      if (redundant_include_p (fname))
diff -cr gcc-2.6/cp/lex.c g:gcc-2.6/cp/lex.c
*** gcc-2.6/cp/lex.c	Wed Jun 15 19:29:06 1994
--- g:gcc-2.6/cp/lex.c	Wed Aug 24 19:13:40 1994
***************
*** 1,3 ****
--- 1,4 ----
+ /* lex.c -- changed for emx by Eberhard Mattes -- Aug 1994 */
  /* Separate lexical analyzer for GNU C++.
     Copyright (C) 1987, 1989, 1992, 1993, 1994 Free Software Foundation, Inc.
     Hacked by Michael Tiemann (tiemann@cygnus.com)
***************
*** 2575,2580 ****
--- 2576,2635 ----
  		      TREE_INT_CST_HIGH (fileinfo) = interface_unknown;
  		    }
  		}
+ #ifdef EMX
+               else if (c == 'p'
+                        && getch () == 'a'
+                        && getch () == 'c'
+ 		       && getch () == 'k')
+                 {
+                   int align;
+                   extern int maximum_field_alignment;
+ 
+                   align = -1;
+                   do
+                     {
+                       nextchar = getch ();
+                     } while (nextchar == ' ' || nextchar == '\t');
+                   if (nextchar == '(')
+                     {
+                       do
+                         {
+                           nextchar = getch ();
+                         } while (nextchar == ' ' || nextchar == '\t');
+                       switch (nextchar)
+                         {
+                         case ')':
+                           align = 0;
+                           break;
+                         case '1':
+                         case '2':
+                         case '4':
+                           align = nextchar - '0';
+                           break;
+                         }
+                       if (nextchar != ')')
+                         do
+                           {
+                             nextchar = getch ();
+                           } while (nextchar == ' ' || nextchar == '\t');
+                       if (nextchar != ')')
+                         align = -1;
+                     }
+                   if (align < 0)
+                     {
+                       error ("invalid #pragma pack");
+                       goto skipline;
+                     }
+                   maximum_field_alignment = align * 8;
+                   do
+                     {
+                       nextchar = getch ();
+                     } while (nextchar == ' ' || nextchar == '\t');
+                   c = nextchar;
+ 		  if (c != '\n')
+ 		    warning ("trailing characters ignored");
+ 		}
+ #endif /* EMX */
  	    }
  	  goto skipline;
  	}
diff -cr gcc-2.6/explow.c g:gcc-2.6/explow.c
*** gcc-2.6/explow.c	Thu Jul 14 14:41:30 1994
--- g:gcc-2.6/explow.c	Thu Oct 06 00:21:56 1994
***************
*** 1,3 ****
--- 1,5 ----
+ /* explow.c -- changed for emx by Eberhard Mattes -- Oct 1994 */
+ 
  /* Subroutines for manipulating rtx's in semantically interesting ways.
     Copyright (C) 1987, 1991, 1994 Free Software Foundation, Inc.
  
***************
*** 714,719 ****
--- 716,756 ----
    if (adjust == const0_rtx)
      return;
  
+ #ifdef EMX
+   if (TARGET_PROBE &&
+           (GET_CODE (adjust) != CONST_INT || INTVAL (adjust) >= PROBE_SIZE))
+     {
+       int i, j;
+ 
+       if (GET_CODE (adjust) == CONST_INT && INTVAL (adjust) <= PROBE_MAX_INLINE)
+         {
+           i = INTVAL (adjust); j = 0;
+           while (i >= PROBE_SIZE)
+             {
+               i -= PROBE_SIZE; j += PROBE_SIZE;
+ /* (set (mem:QI (plus:SI (reg:SI 7) (const_int -j)) (const_int 0))) */
+               emit_insn (gen_rtx (SET, VOIDmode,
+                            gen_rtx (MEM, QImode,
+                              gen_rtx (PLUS, Pmode,
+                                gen_rtx (REG, Pmode, 7), /* esp */
+                                gen_rtx (CONST_INT, SImode, -j))),
+                            const0_rtx));
+             }
+         }
+       else
+         {
+           emit_push_insn (adjust, SImode, 0, 0, 0, 0, 0, 0, 0, 0);
+ /* (call (mem:QI (symbol_ref:SI ("__probe"))) (const_int 1)) */
+           emit_insn (gen_rtx (CALL, VOIDmode,
+                        gen_rtx (MEM, QImode,
+                          gen_rtx (SYMBOL_REF, Pmode, "__probe")),
+                        const1_rtx));
+           /*
+           emit_insn (gen_rtx (ASM_INPUT, VOIDmode, "call ___probe"));
+           */
+         }
+     }
+ #endif /* EMX */
    temp = expand_binop (Pmode,
  #ifdef STACK_GROWS_DOWNWARD
  		       sub_optab,
diff -cr gcc-2.6/gcc.c g:gcc-2.6/gcc.c
*** gcc-2.6/gcc.c	Mon Jul 11 20:08:58 1994
--- g:gcc-2.6/gcc.c	Thu Oct 06 00:20:20 1994
***************
*** 1,3 ****
--- 1,5 ----
+ /* gcc.c -- changed for emx by Eberhard Mattes -- Oct 1994 */
+ 
  /* Compiler driver program that can handle many languages.
     Copyright (C) 1987, 1989, 1992, 1993, 1994 Free Software Foundation, Inc.
  
***************
*** 93,98 ****
--- 95,106 ----
  #define NULL_PTR ((GENERIC_PTR)0)
  #endif
  
+ #ifdef __EMX__
+ #include <process.h>
+ #include <stdlib.h>
+ extern char *_getname();
+ #endif /* __EMX__ */
+ 
  #ifdef USG
  #define vfork fork
  #endif /* USG */
***************
*** 131,142 ****
--- 139,152 ----
  extern void free ();
  extern char *getenv ();
  
+ #ifndef __EMX__
  extern int errno, sys_nerr;
  #if defined(bsd4_4) || defined(__NetBSD__)
  extern const char *const sys_errlist[];
  #else
  extern char *sys_errlist[];
  #endif
+ #endif /* not __EMX__ */
  
  extern int execv (), execvp ();
  
***************
*** 379,384 ****
--- 389,405 ----
  treated as compiler output files, and passed to the linker in their
  proper position among the other output files.  */
  
+ #ifndef EMX
+ 
+ #define EMX_ASM_SPEC_PATCH "%{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o} "
+ 
+ #else /* EMX */
+ 
+ #define EMX_ASM_SPEC_PATCH "%{Zomf:-o %d%g.o}%{!Zomf:\
+ 		            %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}} "
+ 
+ #endif /* EMX */
+ 
  /* Define the macros used for specs %a, %l, %L, %S, %c, %C, %1.  */
  
  /* config.h can define ASM_SPEC to provide extra args to the assembler
***************
*** 544,552 ****
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
! 		      %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
!                       %{!pipe:%g.s} %A\n }}}}"},
    {"-",
     "%{E:cpp -lang-c %{nostdinc*} %{C} %{v} %{A*} %{I*} %{P} %I\
  	%{C:%{!E:%eGNU C does not support -C without using -E}}\
--- 565,573 ----
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
!                       EMX_ASM_SPEC_PATCH
!                       "%{!pipe:%g.s} %A\n }}}}"},
    {"-",
     "%{E:cpp -lang-c %{nostdinc*} %{C} %{v} %{A*} %{I*} %{P} %I\
  	%{C:%{!E:%eGNU C does not support -C without using -E}}\
***************
*** 579,587 ****
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
! 		      %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
!                       %{!pipe:%g.s} %A\n }}}}"},
    {".h", "@c-header"},
    {"@c-header",
     "%{!E:%eCompilation of header file requested} \
--- 600,608 ----
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
! 		      EMX_ASM_SPEC_PATCH
!                       "%{!pipe:%g.s} %A\n }}}}"},
    {".h", "@c-header"},
    {"@c-header",
     "%{!E:%eCompilation of header file requested} \
***************
*** 616,624 ****
  			    %{f*} %{+e*} %{aux-info*}\
  			    %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  			    %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}}|\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
! 		      %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
!                       %{!pipe:%g.s} %A\n }}}}"},
    {".i", "@cpp-output"},
    {"@cpp-output",
     "%{!M:%{!MM:%{!E:cc1 %i %1 %{!Q:-quiet} %{d*} %{m*} %{a}\
--- 637,645 ----
  			    %{f*} %{+e*} %{aux-info*}\
  			    %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  			    %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}}|\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
! 		      EMX_ASM_SPEC_PATCH
!                       "%{!pipe:%g.s} %A\n }}}}"},
    {".i", "@cpp-output"},
    {"@cpp-output",
     "%{!M:%{!MM:%{!E:cc1 %i %1 %{!Q:-quiet} %{d*} %{m*} %{a}\
***************
*** 627,635 ****
  			%{aux-info*}\
  			%{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  			%{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
! 		     %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
! 			     %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
! 			     %{!pipe:%g.s} %A\n }}}}"},
    {".ii", "@c++-cpp-output"},
    {"@c++-cpp-output",
     "%{!M:%{!MM:%{!E:cc1plus %i %1 %2 %{!Q:-quiet} %{d*} %{m*} %{a}\
--- 648,656 ----
  			%{aux-info*}\
  			%{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  			%{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
! 		     %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
! 			     EMX_ASM_SPEC_PATCH
! 			     "%{!pipe:%g.s} %A\n }}}}"},
    {".ii", "@c++-cpp-output"},
    {"@c++-cpp-output",
     "%{!M:%{!MM:%{!E:cc1plus %i %1 %2 %{!Q:-quiet} %{d*} %{m*} %{a}\
***************
*** 638,651 ****
  			    %{f*} %{+e*} %{aux-info*}\
  			    %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  			    %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
! 	            %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
! 			    %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
! 			    %{!pipe:%g.s} %A\n }}}}"},
    {".s", "@assembler"},
    {"@assembler",
!    "%{!M:%{!MM:%{!E:%{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
! 		            %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
! 			    %i %A\n }}}}"},
    {".S", "@assembler-with-cpp"},
    {"@assembler-with-cpp",
     "cpp -lang-asm %{nostdinc*} %{C} %{v} %{A*} %{I*} %{P} %I\
--- 659,672 ----
  			    %{f*} %{+e*} %{aux-info*}\
  			    %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  			    %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
! 	            %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
! 			    EMX_ASM_SPEC_PATCH
! 			    "%{!pipe:%g.s} %A\n }}}}"},
    {".s", "@assembler"},
    {"@assembler",
!    "%{!M:%{!MM:%{!E:%{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
! 		            EMX_ASM_SPEC_PATCH
! 			    "%i %A\n }}}}"},
    {".S", "@assembler-with-cpp"},
    {"@assembler-with-cpp",
     "cpp -lang-asm %{nostdinc*} %{C} %{v} %{A*} %{I*} %{P} %I\
***************
*** 656,664 ****
          %{traditional-cpp:-traditional}\
  	%{g*} %{W*} %{w} %{pedantic*} %{H} %{d*} %C %{D*} %{U*} %{i*}\
          %i %{!M:%{!MM:%{!E:%{!pipe:%g.s}}}}%{E:%W{o*}}%{M:%W{o*}}%{MM:%W{o*}} |\n",
!    "%{!M:%{!MM:%{!E:%{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
!                     %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
! 		    %{!pipe:%g.s} %A\n }}}}"},
    {".ads", "@ada"},
    {".adb", "@ada"},
    {".ada", "@ada"},
--- 677,685 ----
          %{traditional-cpp:-traditional}\
  	%{g*} %{W*} %{w} %{pedantic*} %{H} %{d*} %C %{D*} %{U*} %{i*}\
          %i %{!M:%{!MM:%{!E:%{!pipe:%g.s}}}}%{E:%W{o*}}%{M:%W{o*}}%{MM:%W{o*}} |\n",
!    "%{!M:%{!MM:%{!E:%{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
!                     EMX_ASM_SPEC_PATCH
! 		    "%{!pipe:%g.s} %A\n }}}}"},
    {".ads", "@ada"},
    {".adb", "@ada"},
    {".ada", "@ada"},
***************
*** 668,676 ****
  			  %{d*}\
  			  %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  			  %i %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
! 		    %{!S:%{!gnatc:%{!gnats:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
! 					      %{c:%W{o*}%{!o*:-o %w%b.o}}\
! 					      %{!c:-o %d%w%u.o} %{!pipe:%g.s} %A\n}}}}}} "},
    /* Mark end of table */
    {0, 0}
  };
--- 689,697 ----
  			  %{d*}\
  			  %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  			  %i %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
! 		    %{!S:%{!gnatc:%{!gnats:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
! 					      EMX_ASM_SPEC_PATCH
! 					      "%{!pipe:%g.s} %A\n}}}}}} "},
    /* Mark end of table */
    {0, 0}
  };
***************
*** 707,718 ****
--- 728,757 ----
  			%{L*} %{T*} %o %{!nostdlib:libgcc.a%s %L libgcc.a%s %{!A:%E}}\n }}}}}}";
  #else
  /* Use -L and have the linker do the search for -lgcc.  */
+ #ifndef EMX
  static char *link_command_spec = "\
  %{!fsyntax-only: \
   %{!c:%{!M:%{!MM:%{!E:%{!S:ld %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} \
  			%{r} %{s} %{t} %{u*} %{x} %{z} %{Z}\
  			%{!A:%{!nostartfiles:%{!nostdlib:%S}}} %{static:}\
  			%{L*} %D %{T*} %o %{!nostdlib:-lgcc %L -lgcc %{!A:%E}}\n }}}}}}";
+ #else /* EMX */
+ static char *link_command_spec = "\
+ %{!fsyntax-only: \
+  %{!c:%{!M:%{!MM:%{!E:%{!S:%{!Zomf:ld}%{Zomf:emxomfld %{Zdll}}\
+ 			%l %X %{o*} %{!o:-o %b.%{Zdll:dll}%{!Zdll:exe}} \
+ 			%{A} %{d} %{e*} %{m} %{N} %{n} \
+ 			%{r} %{s} %{t} %{u*} %{x} %{z} \
+ 			%{Zexe} %{Zstack*} %{Zmap*} \
+ 			%{!A:%{!nostartfiles:%{!nostdlib:%S}}} %{static:}\
+ 			%{L*} %D %{T*} %o \
+ 			%{!nostdlib:%{Zmtd:-lcdll -los2 -lemx2} \
+ 			%{!Zmtd:-lgcc %L -lgcc \
+ 			%{Zsys:%{!Zmts:-lsysst}%{Zmts:-lsysmt} -los2} \
+ 			%{!Zsys:%{!Zmts:-lemxst}%{Zmts:-lemxmt} \
+ 			-los2 -lemx2}} \
+ 			%{!A:%E}}\n }}}}}}";
+ #endif /* EMX */
  #endif
  #endif
  
***************
*** 1505,1511 ****
--- 1544,1554 ----
    len = strlen (base);
    temp_filename = xmalloc (len + sizeof("/ccXXXXXX") + 1);
    strcpy (temp_filename, base);
+ #ifndef __EMX__
    if (len > 0 && temp_filename[len-1] != '/')
+ #else /* __EMX__ */
+   if (len > 0 && temp_filename[len-1] != '/' && temp_filename[len-1] != '\\')
+ #endif /* __EMX__ */
      temp_filename[len++] = '/';
    strcpy (temp_filename + len, "ccXXXXXX");
  
***************
*** 1924,1929 ****
--- 1967,2035 ----
  
  #else /* not __MSDOS__ */
  
+ #ifdef __EMX__
+ 
+ static int
+ pexecute (search_flag, program, argv, not_last)
+      int search_flag;
+      char *program;
+      char *argv[];
+      int not_last;
+ {
+   int pid;
+   int pdes[2], org_stdin, org_stdout;
+   int input_desc = last_pipe_input;
+   int output_desc = STDOUT_FILE_NO;
+ 
+   /* If this isn't the last process, make a pipe for its output,
+      and record it as waiting to be the input to the next process.  */
+ 
+   if (not_last)
+     {
+       if (pipe (pdes) < 0)
+ 	pfatal_with_name ("pipe");
+       output_desc = pdes[WRITE_PORT];
+       last_pipe_input = pdes[READ_PORT];
+     }
+   else
+     last_pipe_input = STDIN_FILE_NO;
+ 
+   if (_osmode != DOS_MODE && input_desc != STDIN_FILE_NO)
+     {
+       org_stdin = dup (STDIN_FILE_NO);
+       dup2 (input_desc, STDIN_FILE_NO);
+       close (input_desc); 
+     }
+   if (_osmode != DOS_MODE && output_desc != STDOUT_FILE_NO)
+     {
+       org_stdout = dup (STDOUT_FILE_NO);
+       dup2 (output_desc, STDOUT_FILE_NO);
+       close (output_desc);
+     }
+   pid = (search_flag ? spawnv : spawnvp) (P_NOWAIT, program,
+                                           (char const * const *)argv);
+   if (_osmode != DOS_MODE && input_desc != STDIN_FILE_NO)
+     {
+       dup2 (org_stdin, STDIN_FILE_NO);
+       close (org_stdin);
+     }
+   if (_osmode != DOS_MODE && output_desc != STDOUT_FILE_NO)
+     {
+       dup2 (org_stdout, STDOUT_FILE_NO);
+       close (org_stdout);
+     }
+ 
+   if (pid == -1)
+     {
+       perror_exec (program);
+       exit (-1);
+     }
+ 
+   return pid;
+ }
+ 
+ #else /* not __EMX__ */
+ 
  static int
  pexecute (search_flag, program, argv, not_last)
       int search_flag;
***************
*** 2012,2017 ****
--- 2118,2124 ----
      }
  }
  
+ #endif /* not __EMX__ */
  #endif /* not __MSDOS__ */
  #else /* not OS2 */
  
***************
*** 2072,2077 ****
--- 2179,2188 ----
  #ifdef __MSDOS__
          fatal ("-pipe not supported under MS-DOS");
  #endif
+ #ifdef __EMX__
+         if (_osmode == DOS_MODE)
+           fatal ("-pipe not supported under MS-DOS");
+ #endif /* __EMX__ */
  	argbuf[i] = 0;	/* termination of command args.  */
  	commands[n_commands].prog = argbuf[i + 1];
  	commands[n_commands].argv = &argbuf[i + 1];
***************
*** 2412,2417 ****
--- 2523,2549 ----
  
  	  linker_options[n_linker_options - 1] = argv[++i];
  	}
+ #ifdef EMX
+       else if (! strcmp (argv[i], "-Zlinker"))
+ 	{
+ 	  /* Pass the argument of this option to LINK386 when we link.	*/
+ 
+ 	  if (i + 1 == argc)
+ 	    fatal ("argument to `-Zlinker' is missing");
+ 
+ 	  n_linker_options += 2;
+ 	  if (!linker_options)
+ 	    linker_options
+ 	      = (char **) xmalloc (n_linker_options * sizeof (char **));
+ 	  else
+ 	    linker_options
+ 	      = (char **) xrealloc (linker_options,
+ 				    n_linker_options * sizeof (char **));
+ 
+ 	  linker_options[n_linker_options - 2] = "-O";
+ 	  linker_options[n_linker_options - 1] = argv[++i];
+ 	}
+ #endif /* EMX */
        else if (! strncmp (argv[i], "-Wl,", 4))
  	{
  	  int prev, j;
***************
*** 2627,2632 ****
--- 2759,2768 ----
        /* Just skip the switches that were handled by the preceding loop.  */
        if (!strcmp (argv[i], "-Xlinker"))
  	i++;
+ #ifdef EMX
+       else if (!strcmp (argv[i], "-Zlinker"))
+ 	i++;
+ #endif /* EMX */
        else if (! strncmp (argv[i], "-Wl,", 4))
  	;
        else if (! strncmp (argv[i], "-Wa,", 4))
***************
*** 4012,4021 ****
--- 4148,4168 ----
    char *specs_file;
    char *p;
  
+ #ifndef __EMX__
    p = argv[0] + strlen (argv[0]);
    while (p != argv[0] && p[-1] != '/') --p;
+ #else /* __EMX__ */
+   p = _getname (argv[0]);
+ #endif /* __EMX__ */
    programname = p;
  
+ #ifdef __EMX__
+   _emxload_env ("GCCLOAD");
+   _envargs (&argc, &argv, "GCCOPT");
+   _response (&argc, &argv);
+   _wildcard (&argc, &argv);
+ #endif /* __EMX__ */
+ 
    if (signal (SIGINT, SIG_IGN) != SIG_IGN)
      signal (SIGINT, fatal_error);
  #ifdef SIGHUP
***************
*** 4308,4313 ****
--- 4455,4478 ----
  	}
        obstack_grow (&collect_obstack, "\0", 1);
        putenv (obstack_finish (&collect_obstack));
+ 
+ #ifdef EMX
+       /* Substitute the basename of the first input file for %b in
+ 	 link_command_spec. */
+ 
+       input_basename = infiles[0].name;
+       for (p = input_basename; *p; p++)
+ 	if (*p == '/')
+ 	  input_basename = p + 1;
+ 
+       /* Find a suffix starting with the last period,
+ 	 and set basename_length to exclude that suffix.  */
+       basename_length = strlen (input_basename);
+       p = input_basename + basename_length;
+       while (p != input_basename && *p != '.') --p;
+       if (*p == '.' && p != input_basename)
+ 	basename_length = p - input_basename;
+ #endif /* EMX */
  
        value = do_spec (link_command_spec);
        if (value < 0)
diff -cr gcc-2.6/objc/sendmsg.c g:gcc-2.6/objc/sendmsg.c
*** gcc-2.6/objc/sendmsg.c	Mon Jul 11 19:02:20 1994
--- g:gcc-2.6/objc/sendmsg.c	Sun Aug 28 20:20:58 1994
***************
*** 68,74 ****
  }
  
  /* Given a class and selector, return the selector's implementation.  */
! __inline__ IMP
  get_imp (Class* class, SEL sel)
  {
    IMP impl;
--- 68,77 ----
  }
  
  /* Given a class and selector, return the selector's implementation.  */
! #if 0
! __inline__
! #endif
! IMP
  get_imp (Class* class, SEL sel)
  {
    IMP impl;
diff -cr gcc-2.6/objc-act.c g:gcc-2.6/objc-act.c
*** gcc-2.6/objc-act.c	Mon Jul 11 23:14:28 1994
--- g:gcc-2.6/objc-act.c	Sun Oct 09 22:48:30 1994
***************
*** 1,3 ****
--- 1,4 ----
+ /* objc-act.c -- changed for emx by Eberhard Mattes -- Oct 1994 */
  /* Implement classes and message passing for Objective C.
     Copyright (C) 1992, 1993 Free Software Foundation, Inc.
     Author: Steve Naroff.
***************
*** 1568,1579 ****
      c_expand_expr_stmt (decelerator);
  
      TREE_PUBLIC (current_function_decl) = 1;
-     DECL_EXTERNAL (current_function_decl) = 1;
  
      finish_function (0);
  
      /* Return the name of the constructor function.  */
!     return IDENTIFIER_POINTER (init_function_name);
    }
  }
  
--- 1569,1580 ----
      c_expand_expr_stmt (decelerator);
  
      TREE_PUBLIC (current_function_decl) = 1;
  
+     function_decl = current_function_decl;
      finish_function (0);
  
      /* Return the name of the constructor function.  */
!     return XSTR (XEXP (DECL_RTL (function_decl), 0), 0);
    }
  }
  
***************
*** 1788,1793 ****
--- 1789,1795 ----
        initlist = build_constructor (TREE_TYPE (UOBJC_SELECTOR_TABLE_decl),
  				    nreverse (initlist));
        finish_decl (UOBJC_SELECTOR_TABLE_decl, initlist, NULLT);
+       current_function_decl = NULLT;
      }
  }
  
diff -cr gcc-2.6/toplev.c g:gcc-2.6/toplev.c
*** gcc-2.6/toplev.c	Thu Jul 07 03:58:54 1994
--- g:gcc-2.6/toplev.c	Thu Oct 06 00:24:08 1994
***************
*** 1,3 ****
--- 1,5 ----
+ /* toplev.c -- changed for emx by Eberhard Mattes -- Oct 1994 */
+ 
  /* Top level of GNU C compiler
     Copyright (C) 1987, 88, 89, 92, 93, 1994 Free Software Foundation, Inc.
  
***************
*** 2013,2018 ****
--- 2015,2023 ----
  
    if (dump_base_name == 0)
      dump_base_name = name ? name : "gccdump";
+ #ifdef __EMX__
+   /* TODO */
+ #endif /* __EMX__ */
  
    parse_time = 0;
    varconst_time = 0;
***************
*** 2088,2126 ****
--- 2093,2167 ----
  
    /* If jump_opt dump desired, open the output file.  */
    if (jump_opt_dump)
+ #ifndef __EMX__
      jump_opt_dump_file = open_dump_file (dump_base_name, ".jump");
+ #else /* __EMX__ */
+     jump_opt_dump_file = open_dump_file (dump_base_name, ".jp1");
+ #endif /* __EMX__ */
  
    /* If cse dump desired, open the output file.  */
    if (cse_dump)
+ #ifndef __EMX__
      cse_dump_file = open_dump_file (dump_base_name, ".cse");
+ #else /* __EMX__ */
+     cse_dump_file = open_dump_file (dump_base_name, ".cs1");
+ #endif /* __EMX__ */
  
    /* If loop dump desired, open the output file.  */
    if (loop_dump)
+ #ifndef __EMX__
      loop_dump_file = open_dump_file (dump_base_name, ".loop");
+ #else /* __EMX__ */
+     loop_dump_file = open_dump_file (dump_base_name, ".loo");
+ #endif /* __EMX__ */
  
    /* If cse2 dump desired, open the output file.  */
    if (cse2_dump)
+ #ifndef __EMX__
      cse2_dump_file = open_dump_file (dump_base_name, ".cse2");
+ #else /* __EMX__ */
+     cse2_dump_file = open_dump_file (dump_base_name, ".cs2");
+ #endif /* __EMX__ */
  
    /* If flow dump desired, open the output file.  */
    if (flow_dump)
+ #ifndef __EMX__
      flow_dump_file = open_dump_file (dump_base_name, ".flow");
+ #else /* __EMX__ */
+     flow_dump_file = open_dump_file (dump_base_name, ".flo");
+ #endif /* __EMX__ */
  
    /* If combine dump desired, open the output file.  */
    if (combine_dump)
+ #ifndef __EMX__
      combine_dump_file = open_dump_file (dump_base_name, ".combine");
+ #else /* __EMX__ */
+     combine_dump_file = open_dump_file (dump_base_name, ".cmb");
+ #endif /* __EMX__ */
  
    /* If scheduling dump desired, open the output file.  */
    if (sched_dump)
+ #ifndef __EMX__
      sched_dump_file = open_dump_file (dump_base_name, ".sched");
+ #else /* __EMX__ */
+     sched_dump_file = open_dump_file (dump_base_name, ".sd1");
+ #endif /* __EMX__ */
  
    /* If local_reg dump desired, open the output file.  */
    if (local_reg_dump)
+ #ifndef __EMX__
      local_reg_dump_file = open_dump_file (dump_base_name, ".lreg");
+ #else /* __EMX__ */
+     local_reg_dump_file = open_dump_file (dump_base_name, ".lre");
+ #endif /* __EMX__ */
  
    /* If global_reg dump desired, open the output file.  */
    if (global_reg_dump)
+ #ifndef __EMX__
      global_reg_dump_file = open_dump_file (dump_base_name, ".greg");
+ #else /* __EMX__ */
+     global_reg_dump_file = open_dump_file (dump_base_name, ".gre");
+ #endif /* __EMX__ */
  
    /* If 2nd scheduling dump desired, open the output file.  */
    if (sched2_dump)
***************
*** 2128,2134 ****
--- 2169,2179 ----
  
    /* If jump2_opt dump desired, open the output file.  */
    if (jump2_opt_dump)
+ #ifndef __EMX__
      jump2_opt_dump_file = open_dump_file (dump_base_name, ".jump2");
+ #else /* __EMX__ */
+     jump2_opt_dump_file = open_dump_file (dump_base_name, ".jp2");
+ #endif /* __EMX__ */
  
    /* If dbr_sched dump desired, open the output file.  */
    if (dbr_sched_dump)
***************
*** 2138,2144 ****
--- 2183,2193 ----
  
    /* If stack_reg dump desired, open the output file.  */
    if (stack_reg_dump)
+ #ifndef __EMX__
      stack_reg_dump_file = open_dump_file (dump_base_name, ".stack");
+ #else /* __EMX__ */
+     stack_reg_dump_file = open_dump_file (dump_base_name, ".stk");
+ #endif /* __EMX__ */
  
  #endif
  
***************
*** 3328,3333 ****
--- 3377,3386 ----
    int version_flag = 0;
    char *p;
  
+ #ifdef __EMX__
+   _emxload_env ("GCCLOAD");
+ #endif /* __EMX__ */
+ 
    /* save in case md file wants to emit args as a comment.  */
    save_argc = argc;
    save_argv = argv;
***************
*** 3940,3950 ****
--- 3993,4005 ----
  	       lim - (char *) &environ);
        fflush (stderr);
  
+ #ifndef __EMX__
  #ifdef USG
        system ("ps -l 1>&2");
  #else /* not USG */
        system ("ps v");
  #endif /* not USG */
+ #endif /* not __EMX__ */
      }
  #endif /* not VMS */
  #endif /* not OS2 */
diff -cr gcc-2.6/varasm.c g:gcc-2.6/varasm.c
*** gcc-2.6/varasm.c	Tue Jul 12 00:25:28 1994
--- g:gcc-2.6/varasm.c	Thu Oct 06 00:24:56 1994
***************
*** 1,3 ****
--- 1,5 ----
+ /* varasm.c -- changed for emx by Eberhard Mattes -- Oct 1994 */
+ 
  /* Output variables, constants and external declarations, for GNU compiler.
     Copyright (C) 1987, 88, 89, 92, 93, 1994 Free Software Foundation, Inc.
  
***************
*** 718,723 ****
--- 720,726 ----
      text_section ();
  
    /* Tell assembler to move to target machine's alignment for functions.  */
+ #ifndef EMX
    align = floor_log2 (FUNCTION_BOUNDARY / BITS_PER_UNIT);
    if (align > 0)
      {
***************
*** 726,731 ****
--- 729,744 ----
        else
  	ASM_OUTPUT_ALIGN (asm_out_file, align);
      }
+ #else /* EMX */
+   if (output_bytecode)
+     {
+       align = floor_log2 (FUNCTION_BOUNDARY / BITS_PER_UNIT);
+       if (align > 0)
+ 	BC_OUTPUT_ALIGN (asm_out_file, align);
+     }
+   else
+     ASM_OUTPUT_ALIGN_CODE (asm_out_file);
+ #endif /* EMX */
  
  #ifdef ASM_OUTPUT_FUNCTION_PREFIX
    ASM_OUTPUT_FUNCTION_PREFIX (asm_out_file, fnname);
***************
*** 1564,1570 ****
--- 1577,1585 ----
  {
    char label[256];
    char *name;
+ #ifndef EMX
    int align;
+ #endif /* EMX */
  
    /* Shouldn't get here */
    if (output_bytecode)
***************
*** 1579,1587 ****
--- 1594,1606 ----
  #endif
  
    /* Write the assembler code to define one.  */
+ #ifndef EMX
    align = floor_log2 (FUNCTION_BOUNDARY / BITS_PER_UNIT);
    if (align > 0)
      ASM_OUTPUT_ALIGN (asm_out_file, align);
+ #else /* EMX */
+   ASM_OUTPUT_ALIGN_CODE (asm_out_file);
+ #endif /* EMX */
  
    ASM_OUTPUT_INTERNAL_LABEL (asm_out_file, "LTRAMP", 0);
    TRAMPOLINE_TEMPLATE (asm_out_file);
